static void GEZAMPSaveSetting(void)
{
	int i;
#if 0
	SetSettingString("RhythmWaveFilePath", setting.rhythmpath);
#endif

	for (i = 0; freqlist[i].key != NULL; i++)
	{
		if (setting.frequency == freqlist[i].num) break;
	}
	if (freqlist[i].key == NULL) i = 0;
	SetSettingString("Frequency", freqlist[i].key);

	for (i = 0; priolist[i].key != NULL; i++)
	{
		if (setting.priority == priolist[i].num) break;
	}
	if (priolist[i].key == NULL) i = 2;
	SetSettingString("Priority", priolist[i].key);

	SetSettingInt("LoopCount"   , setting.loopcount);
	SetSettingInt("FadeoutTime" , setting.fadetime);
}

static void GEZAMPLoadSetting(void)
{
	LPTSTR fnoff;
	char path[MAX_PATH];
	int i;

	GetFullPathName(setting.cfgname, MAX_PATH, path, &fnoff);
	path[(fnoff - path)] = '\0';
	opn2.Init(OPNA_CLOCK, SOUND_44K, true, 0);
#if 0
	GetSettingString("RhythmWaveFilePath", path, setting.rhythmpath, sizeof(setting.rhythmpath));
	opn2.Init(OPNA_CLOCK, SOUND_44K, true, setting.rhythmpath);
	lstrcpy(setting.currentrhythmpath, setting.rhythmpath);
	for (i = 0; i < 6; i++)
		opn2.SetVolumeRhythm(i, 20);
#endif


	GetSettingString("Frequency", freqlist[0].key, path, sizeof(path));
	for (i = 0; freqlist[i].key != NULL; i++)
	{
		if (lstrcmpi(path, freqlist[i].key) == 0) break;
	}
	setting.frequency = freqlist[i].num;

	GetSettingString("Priority", priolist[2].key, path, sizeof(path));
	for (i = 0; priolist[i].key != NULL; i++)
	{
		if (lstrcmpi(path, priolist[i].key) == 0) break;
	}
	setting.priority = priolist[i].num;

	setting.loopcount = GetSettingInt("LoopCount"   , 2);
	setting.fadetime  = GetSettingInt("FadeoutTime" , 5000);

	setting.fmtimersync = 1;

	GEZAMPSaveSetting();
}

static void GEZAMPApplySetting(HWND hwndDlg)
{
	int i;
	char buf[MAX_PATH];
	BOOL bFlag;
#if 0
	GetDlgItemText(hwndDlg, IDC_RHYTHM, setting.rhythmpath, sizeof(setting.rhythmpath));
#endif
	GetDlgItemText(hwndDlg, IDC_PRIORITY, buf, sizeof(buf));
	for (i = 0; priolist[i].key != NULL; i++)
	{
		if (lstrcmpi(buf, priolist[i].key) == 0) break;
	}
	setting.priority = priolist[i].num;

	GetDlgItemText(hwndDlg, IDC_FREQUENCY, buf, sizeof(buf));
	for (i = 0; freqlist[i].key != NULL; i++)
	{
		if (lstrcmpi(buf, freqlist[i].key) == 0) break;
	}
	setting.frequency = freqlist[i].num;

	setting.loopcount = GetDlgItemInt(hwndDlg, IDC_LOOP, &bFlag, FALSE);
	if (bFlag == FALSE || setting.loopcount > 0xff)
		setting.loopcount = 2;

	setting.fadetime = GetDlgItemInt(hwndDlg, IDC_FADEOUT, &bFlag, FALSE);
	if (bFlag == FALSE || setting.fadetime > 0x7fff)
		setting.fadetime = 5000;

	GEZAMPSaveSetting();
}

static BOOL CALLBACK GEZAMPSettingProc(
	HWND hwndDlg,
	UINT uMsg,
	WPARAM wParam,
	LPARAM lParam
)
{
	int i;
#define MAXX(a,b) ((a > b) ? a : b)
	char buf[MAXX(512, MAX_PATH)];
	switch (uMsg)
	{
		case WM_INITDIALOG:
			SendDlgItemMessage(hwndDlg, IDC_PRIORITY, CB_SETEXTENDEDUI, TRUE, 0);
			for (i = 0; priolist[i].key != NULL; i++)
			{
				SendDlgItemMessage(hwndDlg, IDC_PRIORITY, CB_ADDSTRING, 0, (LPARAM)priolist[i].key);
			}
			for (i = 0; priolist[i].key != NULL; i++)
			{
				if (setting.priority == priolist[i].num) break;
			}
			if (priolist[i].key == NULL) i = 2;
			SendDlgItemMessage(hwndDlg, IDC_PRIORITY, CB_SELECTSTRING, -1, (LPARAM)priolist[i].key);

			SendDlgItemMessage(hwndDlg, IDC_FREQUENCY, CB_SETEXTENDEDUI, TRUE, 0);
			for (i = 0; freqlist[i].key != NULL; i++)
			{
				SendDlgItemMessage(hwndDlg, IDC_FREQUENCY, CB_ADDSTRING, 0, (LPARAM)freqlist[i].key);
			}
			for (i = 0; freqlist[i].key != NULL; i++)
			{
				if (setting.frequency == freqlist[i].num) break;
			}
			if (freqlist[i].key == NULL) i = 0;
			SendDlgItemMessage(hwndDlg, IDC_FREQUENCY, CB_SELECTSTRING, -1, (LPARAM)freqlist[i].key);
#if 0
			SetDlgItemText(hwndDlg, IDC_RHYTHM, setting.rhythmpath);
#endif
			SetDlgItemInt(hwndDlg, IDC_LOOP, setting.loopcount, FALSE);
			SendDlgItemMessage(hwndDlg, IDC_SPINLOOP, UDM_SETRANGE, 0, MAKELONG(0xff,0));
			SetDlgItemInt(hwndDlg, IDC_FADEOUT, setting.fadetime, FALSE);
			SendDlgItemMessage(hwndDlg, IDC_SPINFADE, UDM_SETRANGE, 0, MAKELONG(0x7fff,0));

			return TRUE;
		case WM_NOTIFY:
			if (PSN_APPLY == ((LPNMHDR)lParam)->code)
			{
				GEZAMPApplySetting(hwndDlg);
				return TRUE;
			}
			break;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			case IDC_FADEOUT:
			case IDC_LOOP:
				if (HIWORD(wParam) == EN_UPDATE)
				{
					PropSheet_Changed(hwndDlg, PropSheet_GetCurrentPageHwnd(hwndDlg));
					return TRUE;
				}
				break;
			case IDC_PRIORITY:
			case IDC_FREQUENCY:
				if (HIWORD(wParam) == CBN_SELCHANGE)
				{
					PropSheet_Changed(hwndDlg, PropSheet_GetCurrentPageHwnd(hwndDlg));
					return TRUE;
				}
				break;
			case IDC_RHYTHMBROWSE:
				if (HIWORD(wParam) == BN_CLICKED)
				{
					LPMALLOC lpMalloc = NULL;
					LPITEMIDLIST lpidlFolder = NULL;
					do
					{
						BROWSEINFO bi;
						if (FAILED(SHGetMalloc(&lpMalloc))) break;
						bi.hwndOwner = hwndDlg;
						bi.pidlRoot = NULL;
						bi.pszDisplayName = buf;
						bi.lpszTitle = "Rhythm WAV Files Folder";
						bi.ulFlags = BIF_RETURNONLYFSDIRS;
						bi.lpfn = NULL;
						bi.lParam = 0;
						bi.iImage = 0;
						lpidlFolder = SHBrowseForFolder(&bi);
						if (lpidlFolder == NULL) break;
						if (FALSE == SHGetPathFromIDList(lpidlFolder, buf)) break;
						SetDlgItemText(hwndDlg,  IDC_RHYTHM, buf);
					} while(0);
#if defined(__cplusplus) && !defined(IMalloc_Free)
#define IMalloc_Free(t,p) t->Free(p)
#endif
#if defined(__cplusplus) && !defined(IMalloc_Release)
#define IMalloc_Release(t) t->Release()
#endif
					if (lpidlFolder != NULL)
						IMalloc_Free(lpMalloc, lpidlFolder);
					if (lpMalloc != NULL)
						IMalloc_Release(lpMalloc);
					return TRUE;
				}
				break;
			}
			break;
	}
	return FALSE;
}
